#include "stm32f05xxx.h"
#include "spi.h"

// useful references on the raspberry pi side of things: 
// http://www.raspberrypi.org/phpBB3/viewtopic.php?t=11674&p=126932
// http://www.raspberrypi.org/phpBB3/viewtopic.php?f=44&t=39569
// The stm32f0 spi interface is 16 bits in nature and bytes are packed 
// for transmit and reception into this 16 bit register.  This is a 
// bit confusing however the confusion disappears if you transfer quantities
// that are multiples of two bytes in size.

extern short HandleSPICommand(short cmd, short param)
{
	// cmd=0-255
	// param=0-255
	// This function is called from the spi module's interrupt service routine.
	// The raspberry pi will have sent down a command byte and a parameter byte
	// These can be processed as you like and a 16 bit response is sent back
	// 
	switch (cmd)
	{
		case 1: {
			CLEAR_BIT(GPIOC_ODR,BIT8);
			return 0x1234;
			break;
		}
		case 2: {
			SET_BIT(GPIOC_ODR,BIT8);	
			return 0x5678;
			break;
		}
	}
	return 0xffff;
}
void delay(int dly)
{
  while (dly--);
}
int test;
int main()
{
	RCC_AHBENR |= 0x00080000;
    GPIOC_MODER = 0x00010000; // make PC8,PC9 outputs
	initSPI();
	while(1) 
	{
		asm(" WFI ");  // wait for an interrupt and save some power
	}    
}
